package cn.iocoder.yudao.module.llm.service.dataprocesstask;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.llm.controller.admin.dataprocesstask.vo.*;
import cn.iocoder.yudao.module.llm.dal.dataobject.dataprocesstask.DataProcessTaskDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.llm.dal.mysql.dataprocesstask.DataProcessTaskMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * 数据处理任务 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class DataProcessTaskServiceImpl implements DataProcessTaskService {

    @Resource
    private DataProcessTaskMapper dataProcessTaskMapper;

    @Override
    public Long createDataProcessTask(DataProcessTaskSaveReqVO createReqVO) {
        // 插入
        DataProcessTaskDO dataProcessTask = BeanUtils.toBean(createReqVO, DataProcessTaskDO.class);
        dataProcessTaskMapper.insert(dataProcessTask);
        // 返回
        return dataProcessTask.getId();
    }

    @Override
    public void updateDataProcessTask(DataProcessTaskSaveReqVO updateReqVO) {
        // 校验存在
        validateDataProcessTaskExists(updateReqVO.getId());
        // 更新
        DataProcessTaskDO updateObj = BeanUtils.toBean(updateReqVO, DataProcessTaskDO.class);
        dataProcessTaskMapper.updateById(updateObj);
    }

    @Override
    public void deleteDataProcessTask(Long id) {
        // 校验存在
        validateDataProcessTaskExists(id);
        // 删除
        dataProcessTaskMapper.deleteById(id);
    }

    private void validateDataProcessTaskExists(Long id) {
        if (dataProcessTaskMapper.selectById(id) == null) {
            throw exception(DATA_PROCESS_TASK_NOT_EXISTS);
        }
    }

    @Override
    public DataProcessTaskDO getDataProcessTask(Long id) {
        return dataProcessTaskMapper.selectById(id);
    }

    @Override
    public PageResult<DataProcessTaskDO> getDataProcessTaskPage(DataProcessTaskPageReqVO pageReqVO) {
        return dataProcessTaskMapper.selectPage(pageReqVO);
    }

}